package kr.co.tadadang.user.native_bridge

import android.app.Activity
import android.webkit.WebView
import com.google.firebase.ktx.Firebase
import com.google.firebase.messaging.ktx.messaging
import kr.co.tadadang.user.R

class FcmSubscribe : _BaseBridge {

    override val cmd: String
        get() = "fcmSubscribe"

    override fun startAction(
        activity: Activity?,
        webView: WebView?,
        data: String?,
        callback: String?
    ) {
        if (activity == null || data == null || callback == null) return

        when (data) {
            "noti" -> handleSubscription(activity, callback, R.string.topic_noti)
            "marketing" -> handleSubscription(activity, callback, R.string.topic_marketing)
        }
    }

    private fun handleSubscription(activity: Activity, callback: String, topicResId: Int) {
        val topic = activity.getString(topicResId)
        if (callback == "true") {
            Firebase.messaging.subscribeToTopic(topic)
        } else {
            Firebase.messaging.unsubscribeFromTopic(topic)
        }
    }
}
