package kr.co.tadadang.user.sms

import android.content.Context
import android.util.Log
import android.webkit.JavascriptInterface
import android.webkit.WebView
import com.google.android.gms.auth.api.phone.SmsRetriever

class SmsRetrieverInterface(private val context: Context, private val webView: WebView) {
    @JavascriptInterface
    fun startSmsRetriever() {
        val client = SmsRetriever.getClient(context)
        val task = client.startSmsRetriever()
        task.addOnSuccessListener {
            Log.d("song", "SMS Retriever API 시작 성공")
        }
        task.addOnFailureListener { e ->
            Log.d("song", "SMS Retriever API 시작 실패")
        }
    }

    @JavascriptInterface
    fun onSmsReceived(smsMessage: String) {
        webView.post {
            webView.evaluateJavascript("onSmsReceived('$smsMessage')", null)
        }
    }
}